/**
  @file /ai/ai.cpp
  @brief Zdrojovy kod hlavniho modulu umele inteligence.
  
  Zdrojovy kod, ktery inicializuje vsechny moduly umele inteligence, zprostredkovava komunikaci mezi nimi a taktez komunikuje s okolnim svetem pomoci systemu zprav.
  
  @author PZ
  @version 0.1
*/

#include "ai/ai.h"
namespace ai_ns
{

CAIEngine* AIEngine; /// instance CAIEngine viditelna zvenku

void AIInit()
{
  AIEngine=new CAIEngine();
}

void AIDestroy()
{
  delete AIEngine;
}

CAIEngine::CAIEngine()
{
  PathFindEngine=new pathfind_ns::CPathFindEngine();
  DiplomacyEngine=new diplomacy_ns::CDiplomacyEngine();
  StrategyEngine=new strategizer_ns::CStrategizerEngine();
  MapAnalyzerEngine=new mapanalyzer_ns::CMapAnalyzerEngine();
}

CAIEngine::~CAIEngine()
{
  delete PathFindEngine;
  delete DiplomacyEngine;
  delete StrategyEngine;
  delete MapAnalyzerEngine;
}
}
