/**
*******************************************************************************

  @file /common/CommandLine.h
  @brief spousti kralovstvi se spec parametry
  
  @author Vajicek
  @version 0.1
 
******************************************************************************/
#ifndef COMMANDLINE_H
#define COMMANDLINE_H


#include <assert.h>
#include "common/mm.h"
#include "common/types.h"


#define CONNECTTO_SIZE    100
#define DEFAULT_TIMEOUT   15000

/** Parsovani prikazove radky. */
class TCommandLine
{
public:
  /// Mapa ktera se ma spustit
  int iRunMap;

  /// Typ mapy, new=0, save=1
  int iMapType;
  
  /// Vypis help
  int iPrintHelp; 
  
  /// Vypis seznam map
  int iListMaps;
  
  /// Bez zvuku
  int iNoSound;
  
  /// Spust jako sitovy server
  int iNetworkHost;

  /// Spust jako sitovy klient
  int iNetworkClient;
  
  /// Adresa serveru
  char szConnectTo[CONNECTTO_SIZE];

  /// Timeout pro cekani na klienty
  int iTimeOut;

  /// Aktivni vybojarska konzole
  int iDevelopersConsole;
  
  /// Jmeno profilu je definovano
  int iUseProfileName;
  /// Jmeno profilu
  char szProfileName[MAX_STRLEN];

  /** parsovani prikazove radky

    parametry:  
      -m [cislo mapy]     mapa ktera se ma pouzit
      -l [cislo mapy]     nahraj mapu
      -p [jmeno profilu]  profil ktery se ma
      -h vytiskni help
      -s server(+gui)
      -c client
      -t timeout to start
      -x developer's console available
      -e vypis mapy
  */
  TCommandLine(int argc, char** argv);
  
  /// Staticke metody pro vytvoreni a zruseni instance prikazove radky.
  //@{
  /// Jedina instance.
  static TCommandLine* cl;
  /** Vytvori objekt.
    @param argc Pocet parametru prikazove radky.
    @param argv Parametry prikazove radky.
  */
  static void parseCommandLine(int argc, char** argv);
  /** Uvolni z pameti objekt prikazove radky.
  */
  static void freeCommandLine();
  //@}  
};




#endif
/*****************************************************************************/
