/** @file /common/TCL/tcl_struct.h

    Predek vsech TCL-serializovatelnych struktur pouzivanych
    pro predavani dat do TCL interpretu.

    @author Petr Wolf
*/

#ifndef COMMON_TCL_TCL_STRUCT_H
#define COMMON_TCL_TCL_STRUCT_H

#include "common/mm.h"
#include "common/TCL/tcl_script.h"

/** Predek vsech TCL-serializovatelnych struktur pouzivanych
    pro predavani dat do TCL interpretu.
*/
class TTCL_Struct
{
public:
    virtual void readFromTCL(TTCL_Interpreter & interpreter, const char * varName) = 0;
    virtual void writeToTCL(TTCL_Interpreter & interpreter, const char * varName)  = 0;
};

/** Sestaveni adresy prvku v soustave asociativnich poli.
    Funkce vytvari z predanych argumentu validni nazvy promennych
    vyhovujicich zapisu ve stylu
    nazev(nejvyssi_uroven, nizsi_uroven, dalsi_uroven).

    @param result  adresa retezce, do ktereho se ma vysledek zapsat
    @param path    dosavadni nazev promenne
    @param name    index do nejnizsi urovne, ktera ma byt prave pridana nakonec

    @return ukazatel na vysledek, nebo NULL, doslo-li k chybe
*/
char * TCL_path(char * result, const char * path, const char * name);

#endif
/*****************************************************************************/
