/******************************************************************************
*
* @file /common/exc.cpp
*	@brief 8 Kralovstvi - trida s definicemi vyjimek
*
* Zde je definice base tridy vsech vyjimek E_8K.
* Pridavejte sem dalsi dle potreby a libosti (respektive do hlavickoveho souboru).
* 
*
******************************************************************************/


#include <string.h>
#include <exception>
#include "common/Log.h"
#include "exc.h"

using namespace std;

/**
  Definice vlastni unexpected funkce.
  Ta je registrovana na zacatku behu programu v kralovstvi.cpp.
*/
void handleUnexpectedException()
{
  GLOBALLOG("Neocekavana vyjimka !!!");
  // dalsi zpracovani neocekavanych vyjimek
}

E_8K::E_8K()
{
}

E_8K::~E_8K()
{
}

E_8K::E_8K(const char* description)
{
    size_t len = strlen(description);
    if (len>=EXCEPTION_DESCRIPTION_BUFF_LENGTH) len=EXCEPTION_DESCRIPTION_BUFF_LENGTH-1;
    memcpy(desc, description, len);
    desc[len] = '\0'; 

    fn[0] = '\0';
    ln=-1;
}

E_8K::E_8K(const char* description,const char* filename,int linenumber)
{
    size_t len = strlen(description);
    if (len>=EXCEPTION_DESCRIPTION_BUFF_LENGTH) len=EXCEPTION_DESCRIPTION_BUFF_LENGTH-1;
    memcpy(desc, description, len);
    desc[len] = '\0';

    len = strlen(filename);
    if (len>=EXCEPTION_FILENAME_BUFF_LENGTH) len=EXCEPTION_FILENAME_BUFF_LENGTH-1;
    memcpy(fn, filename, len);
    fn[len] = '\0';

    ln=linenumber;    
}

char* E_8K::getDescription()
{
    return desc;
}

char* E_8K::getFileName()
{
    return fn;
}

int E_8K::getLineNumber()
{
    return ln;
}
