/** @file common/mutex.h

    Jednoducha objektova abstrakce SDL_Mutexu.
    Nahrazuje funkce na zamykani (SDL_mutexP()) a 
    odemykani (SDL_mutexV()) mutexu clenskymi
    metodami lock() a unlock().

    @author Petr Wolf
*/

#ifndef COMMON_MUTEX_H
#define COMMON_MUTEX_H

#include <SDL/SDL.h>

class TMutex
{
private:
    SDL_mutex * mutex;
public:
    /// Konstruktor
    TMutex();

    /// Destruktor
    ~TMutex();

    /// Zamceni mutexu
    int lock();

    /// Odemceni mutexu
    int unlock();
};

#endif
