/**
******************************************************************************

  @file /common/rm/rmbuildingi.cpp
  @brief Interface k RMadvxml
  
  @author Vta
  @version 1.0

******************************************************************************/

#include "common/rm/rmbuildingi.h"
namespace rm
{

void TRM_building_i::loadNow(int id)
{
  this->rmbuilding->loadData(id);
}

void TRM_building_i::request(int id)
{
  this->rmbuilding->request(id);
}

void TRM_building_i::requestDep(int id)
{
  this->rmbuilding->requestDep(id);
}

void TRM_building_i::loadBuffer()
{
  this->rmbuilding->loadBuffer();
}

void TRM_building_i::freeData(int id)
{
  this->rmbuilding->freeData(id);
}

int TRM_building_i::getBuildingsCount()
{
  return this->rmbuilding->getCount();
}

int TRM_building_i::getBuildingsLoaded()
{
  return this->rmbuilding->getLoaded();
}

void TRM_building_i::addBuilding(World::BUILDING * building,int startidbuilding,char * buildingfile)
{
  this->rmbuilding->add(building,startidbuilding,buildingfile);
}

void TRM_building_i::addBuildingDep(World::BUILDING * building,int startidbuilding,char * buildingfile,char * buildingname,int startid)
{
  this->rmbuilding->addDep(building,startidbuilding,buildingfile,buildingname,startid);
}

void TRM_building_i::delBuilding(int id)
{
  this->rmbuilding->del(id);
}

void TRM_building_i::delBuildingDep(int id)
{
  this->rmbuilding->delDep(id);
}

void TRM_building_i::modifyBuilding(World::BUILDING * building)
{
  this->rmbuilding->modify(building);
}

void TRM_building_i::getBuildings(DA<World::BUILDING *> ** buildings)
{
  this->rmbuilding->getAll((DA<void*>**)buildings);
}

void TRM_building_i::getIds(DA<int> * ids)
{
  this->rmbuilding->getIds(ids);
}
/*
void TRM_building_i::setBuildings(DA<World::BUILDING *> * buildings)
{
  this->rmbuilding->setAll((DA<void*>*)buildings);
}
*/
void TRM_building_i::get(World::BUILDING ** building,int id)
{
  this->rmbuilding->get((void **)building,id);
}

TRM_building_i::TRM_building_i(TRM_advxml * globalrmbuilding)
{
  this->rmbuilding=globalrmbuilding;

  GLOBALLOGID(PRIORITY_CONFIRM ,"RMbuildingi was created");
}

TRM_building_i::~TRM_building_i()
{
  GLOBALLOGID(PRIORITY_CONFIRM ,"RMbuildingi was destroyed");
}

} // namespace rm
