/**
******************************************************************************

  @file /common/rm/rmbuildingi.h
  @brief Interface k RMadvxml
  
  @author Vta
  @version 1.0

******************************************************************************/

#ifndef _RMbuildingi_
#define _RMbuildingi_

#include "common/rm/rmadvxml.h"


namespace rm
{

/// Interface k RMadvxml
class TRM_building_i
{
  public:
/** @name Nacitani/uvolnovani/ziskani dat */
//@{
    /** Ziska ukazatel na budovu s indexem id */
    void get(World::BUILDING ** building,int id);

    /** Nacte okamzite budovu, ve stejnem vlakne */
    void loadNow(int id); 

    /** Prida pozadavek na nacteni */
    void request(int id); 
    
    /** Prida pozadavek na nacteni a zaroven prida pozadavek na nacteni dat, na ktere se odkazuje */
    void requestDep(int id); 
    
    /** Zpracuje pozadavky na nacteni */
    void loadBuffer();

    /** Uvolni nactenou budovu z pameti */
    void freeData(int id); 

    /** Vraci pocet vsech budov */
    int getBuildingsCount(); 

    /** Vraci pocet doposud nactenych budov */
    int getBuildingsLoaded(); 

    /** Naplni pole ids tak, ze ids[i]==1 pokud budova s danym indexem existuje (nemusi byt vsak nactena), jinak 0 */
    void getIds(DA<int> * ids); 

    /** Dava k dispozici vsechny budovy */
    void getBuildings(DA<World::BUILDING *> ** buildings); 
//@}

/** @name Modifikace, mazani a pridavani dat */
//@{
    /** Prida budovu.
        Pokud je building->id rovno -1, pak prida na prvni volne misto. 
        Predpoklada, ze retezec v RMtxt jiz existuje.
        @param building data pridavane budovy
        @param startidbuilding index od ktereho hledat volny pro novou budovu
        @param buildingfile jmeno souboru, kde budou data ulozeny
    */
    void addBuilding(World::BUILDING * building,int startidbuilding,char * buildingfile); 

    /** Prida budovu a navic prida retezec do RMtxt.
        Pokud je building->id rovno -1, pak prida na prvni volne misto. 
        @param building data pridavane budovy
        @param startidbuilding index od ktereho hledat volny pro novou budovu
        @param buildingfile jmeno souboru, kde budou data ulozeny
        @param buildingname nazev budovy
        @param startid index, od ktereho hledat volne misto pro retezec, pokud building->nameid je rovno -1 (jinak se vlozi na toto misto).
    */
    void addBuildingDep(World::BUILDING * building,int startidbuilding,char * buildingfile,char * buildingname,int startid);

    /** Odebere budovu s indexem id */
    void delBuilding(int id);

    /** Odebere budovu, navic odebere i retezec jmena budovy z RMtxt */
    void delBuildingDep(int id); 

    /** Modifikuje jiz zapsanou budovu */
    void modifyBuilding(World::BUILDING * building);
//@}

/*  todo:  
    void addProductionOfUnitToBuilding(int unitid,int buildingid);
    void removeProductionOfUnitFromBuilding(int unitid,int buildingid);
    void removeProductionOfUnitFromBuildings(int unitid);
    void getProductionOfBuilding(int buildingid,int ** prod);
*/
    /** Konstruktor, ktery musi obsahovat odkaz na RM, ke kteremu toto bude interface */
    TRM_building_i(TRM_advxml * globalrmbuilding);

    /** Destruktor */
    ~TRM_building_i();
  private:
    /** RM ke kteremu je tento interface */
    TRM_advxml * rmbuilding; 
};


} // namespace rm

#endif // indef _RMbuildingi_
/*****************************************************************************/
