/**
******************************************************************************

  @file /common/rm/rmmodeli.cpp
  @brief Interface k RMmodel
  
  @author Vta
  @version 1.0

******************************************************************************/

#include "common/rm/rmmodeli.h"
#ifndef _K_EDITOR_
using namespace gui;
#endif // ifndef
namespace rm
{

int TRM_model_i::startNewGroup()
{
  return this->rmmodel->startNewGroup();
}

int TRM_model_i::getCurrentGroup()
{
  return this->rmmodel->getCurrentGroup();
}

int TRM_model_i::getGroupOfModel(int id)
{
  return this->rmmodel->getGroupOfObject(id);
}

int TRM_model_i::freeLastGroup()
{
  return (this->rmmodel->freeLastGroup());
}

void TRM_model_i::freeModel(int id)
{
  this->rmmodel->freeModel(id);
}

int TRM_model_i::addModel(int id,int startid,char ** filenames,int size)
{
  return this->rmmodel->addModel(id,startid,filenames,size);
}

int TRM_model_i::addModel(int id,int startid,char * main_file)
{
  return this->rmmodel->addModel(id,startid,&main_file,1);
}

void TRM_model_i::addToModel(int id,char * secondary_file)
{
  this->rmmodel->addToModel(id,secondary_file);
}

void TRM_model_i::delModel(int id)
{
  this->rmmodel->delModel(id);
}

int TRM_model_i::getMaxId()
{
   return this->rmmodel->getMaxId();
}
TModel * TRM_model_i::get(int id)
{
  return this->rmmodel->getModel(id);
}

void TRM_model_i::request(int id)
{
  this->rmmodel->request(id);
}

void TRM_model_i::loadBuffer(void)
{
  this->rmmodel->loadBuffer();
}

void TRM_model_i::loadNow(int id)
{
  this->rmmodel->loadModel(id);
}

void TRM_model_i::freeModelsHavingGroup(int group)
{
  this->rmmodel->freeHavingGroup(group);
}
int TRM_model_i::getModels(DA<TModel *> ** models)
{
  return this->rmmodel->getModels(models);
}

int TRM_model_i::getModels(TModel ** models, int size)
{
  DA<TModel *> * daids;
  int j=1,max;
  max=this->rmmodel->getModels(&daids);
  int i;
  for (i=0;i<size;i++)
  {
    if (j==(max+1)) // neni tam vic indexu nez n
    {
      break;
    }
    while ((j<=max) && ((*daids)[j]==NULL))
      j++;
    if ((*daids)[j]!=NULL) // kvuli poslednimu prvku ids[max]
    {
      models[i]=(*daids)[j];
      j++;
    }
  }
  if (j!=(max+1))
    return i;
  else
    return i-1;
}

int TRM_model_i::getModelsCount()
{
  return this->rmmodel->getModelsCount();
}

int TRM_model_i::getModelsLoaded()
{
  return this->rmmodel->getModelsCount();
}

TRM_model_i::TRM_model_i(TRM_model * globalrmmodel)
{
  this->rmmodel=globalrmmodel;
  GLOBALLOGID(PRIORITY_CONFIRM ,"RMmodeli was created");
}

TRM_model_i::~TRM_model_i()
{
  GLOBALLOGID(PRIORITY_CONFIRM ,"RMmodeli was destroyed");
}

} // namespace rm
