/** 
******************************************************************************

  @file /common/rm/rmsoundi.h
  @brief Interface k RMsound
  
  @author Vta
  @version 1.0

******************************************************************************/

#ifndef _RMsoundi_
#define _RMsoundi_

#include "common/rm/rmsound.h"

namespace rm
{

/// Interface k RMsound
class TRM_sound_i
{
  public:
/** @name Nacteni a uvolneni zvuku */
//@{
    void freeSound(int id); 
    void loadNow(int id); 
    void request(int id); 
    void loadBuffer(void); 
//@}

#ifndef _K_EDITOR_
/** @name Ziskani zvuku */
//@{

    /** Start playing music from group playlist */
    void playMusic(int playlist);

    // Ziska hudbu
    Mix_Music * getMusic(int id);

    // Ziska zvuk
    Mix_Chunk * getSample(int id);

    /** Ziska zvuky az do poctu size. Jejich pocet se necha zjistit pomoci getMaxId() */
    int getSounds(TSound ** sounds, int size);
    
    /** Vraci vsechny zvuky v odkaze na pole z RM */
    int getSounds(DA<TSound *> ** snds); 
//@}
#endif

/** @name Prace se skupinami zvuku */
//@{
    /** Zmeni (zvetsi) aktualni pouzitou skupinu */
    int startNewGroup(); 

    /** Vraci nejvetsi (= aktualni) pouzitou skupinu */
    int getCurrentGroup();

    /** Vraci skupinu zvuku s indexem id */
    int getGroupOfSound(int id);

    /** Odstrani zvuky z posledni skupiny. 
        @return index predposleni skupiny (tj. posledni po uvolneni)
    */
    int freeLastGroup(); 
//@}
/** @name Informace o zvucich */
//@{
    /** Vraci pocet vsech zvuku */
    int getSoundsCount(); 

    /** Vraci pocet doposud nactenych soundu */
    int getSoundsLoaded(); 

    /** Vraci nejevsti pouzity index zvuku */
    int getMaxId();
//@}      
    
    /** Konstruktor, ktery musi obsahovat odkaz na RM, ke kteremu toto bude interface */
    TRM_sound_i(TRM_sound * globalrmsound); 

    /** Destruktor */
    ~TRM_sound_i(); 
  private:
    /** RM ke kteremu je tento interface */
    TRM_sound * rmsound;

};

} // namespace rm

#endif // indef _RMsoundi_
/*****************************************************************************/
