/**
******************************************************************************

  @file /common/rm/rmsymboli.cpp
  @brief Interface k RMraster
  
  @author Vta
  @version 1.0

******************************************************************************/

#include "common/rm/rmsymboli.h"
namespace rm
{

void TRM_symbol_i::loadNow(int id)
{
  this->rmsymbol->loadSymbols(id);
}

void TRM_symbol_i::request(int id)
{
  this->rmsymbol->request(id);
}

void TRM_symbol_i::requestDep(int id)
{
  this->rmsymbol->requestSymbolsDep(id);
}

void TRM_symbol_i::loadBuffer()
{
  this->rmsymbol->loadBuffer();
}

void TRM_symbol_i::freeSymbols(int id)
{
  this->rmsymbol->freeSymbols(id);
}

int TRM_symbol_i::getSymbolsCount(int id)
{
  return this->rmsymbol->getSymbolsCount(id);
}

int TRM_symbol_i::getGroupsOfSymbolsCount()
{
  return this->rmsymbol->getGroupsOfSymbolsCount();
}

void TRM_symbol_i::addSymbol(TSymbolData * sym)
{
  this->rmsymbol->addSymbol(sym);
}

void TRM_symbol_i::delSymbol(int group,int id)
{
  this->rmsymbol->delSymbol(group,id);
}

void TRM_symbol_i::modifySymbol(TSymbolData * sym)
{
  this->rmsymbol->modifySymbol(sym);
}

void TRM_symbol_i::addGroup(int group,char * file,int rasterId)
{
  this->rmsymbol->addGroup(group,file,rasterId);
}

void TRM_symbol_i::delGroup(int group)
{
  this->rmsymbol->delGroup(group);
}

void TRM_symbol_i::getSymbol(TSymbolData ** sym,int symgroupid,int symid)
{
  this->rmsymbol->getSymbol(sym, symgroupid, symid);
}

void TRM_symbol_i::getSymbols(TSymbolData ** sym,int id,int size)
{
  this->rmsymbol->getSymbols(sym,id,size);
}

void TRM_symbol_i::getSymbols(DA<TSymbolData*> * sym,int id)
{
  this->rmsymbol->getSymbols(sym,id);
}

TRM_symbol_i::TRM_symbol_i(TRM_symbol * globalrmsymbol)
{
  this->rmsymbol=globalrmsymbol;
  GLOBALLOGID(PRIORITY_CONFIRM ,"RMsymboli was created");
}

TRM_symbol_i::~TRM_symbol_i()
{
  GLOBALLOGID(PRIORITY_CONFIRM ,"RMsymboli was destroyed");
}

} // namespace rm
