/**
*******************************************************************************

  @file /common/types.h
  @brief datove typy a konverze 

  Kdyby, nekomu chybely standardni typy co jsou ve windous, tak tady jsou.

  @author Vajicek
  @version 0.1
 
******************************************************************************/
#ifndef TYPES_H
#define TYPES_H

#include <wchar.h>
#include <string>

/** uzitecne typy */
//(@
#ifndef _DWORD_DEFINED
typedef unsigned long DWORD;
#define _DWORD_DEFINED
#endif

#ifndef _WORD_DEFINED
#define _WORD_DEFINED
typedef unsigned short WORD;
#endif

#ifndef _BYTE_DEFINED
#define _BYTE_DEFINED
typedef unsigned char BYTE;
#endif

typedef int BOOL;
//@)

/** typ pro identifikaci objektu */
typedef void* KHANDLE;  

/** HW identifikator, barvy, displaylisty, svetelny zdroje */
typedef int HWID;

/** identifikator textury v HW rendereru, texture*/
typedef unsigned int HWTID;

/** makra na prepocitani endianu*/
#ifdef BIGENDIAN
	#define LED(D) ((D<<24)|((D&0x0000ff00)<<8)|((D&0x00ff0000)>>8)|(D>>24))
	#define LEW(W) ((W<<8)|(W>>8))
#else
	#define LED(D) D
	#define LEW(W) W
#endif

/** hodnota pointeru na int */
#define PID(a) *((int*)(&a))

/** Typy pro retezce a znaky. PW */
//(@
/// pouzivany typ znaku 
typedef char K8_CHAR;

/// maximalni delka stringu
#define MAX_STRLEN 256

/// obecny typ textoveho retezce vyuzivajici 16-ti bitovou reprezentaci znaku
typedef std::basic_string<K8_CHAR> K8_STRING;
//@)

/// souradnice
struct COORDS
{
    int x;
    int y;
};

/// souradnice cesty
struct PATH_COORDS
{
    int x;
    int y;
    int step_cost;
    int whole_path_cost;
};

#endif
/*****************************************************************************/
