/******************************************************************************

  @file /common/uComputeBorders.h
  @brief Header pro zaplavovy vypocet uzemi.


  @author PZ
  @version 0.1
 
******************************************************************************/

#ifndef uComputeBordersH
#define uComputeBordersH

#pragma warning( disable : 4290 )

#include <deque>
#include <list>
#include "common/exc.h"

static int mapHeight;
static int mapWidth;

typedef struct
{
  int x;
  int y;
  int entityNumber;
} THexOwnership;

/** 
    Funkce, ktera vraci souradnice sousednich hexu.

    @param sourX  X-ova souradnice hexu, jehoz sousedy chci
    @param sourY  Y-ova souradnice hexu, jehoz sousedy chci

    @return list se souradnicemi sousednich hexu
*/
std::list<THexOwnership> chooseNeighbours(int sourX,int sourY);

/** 
    Funkce, ktera naplni masku mapy identifikatory entit zaplavoveho algoritmu.

    @param entityMask   maska, kterou funkce naplni
    @param height       vyska mapy
    @param width        sirka mapy
    @param entitiesnum  pocet vstupnich entit
    @param centers      zaznam se souradnicemi vstupnich entit
    
    @throw E_8K_Editor_InvalidCenters
    
    @return void (funkce naplni masku, predavanou v prvnim parametru)
*/
void computeBorders(int* entityMask,int height,int width,int entitiesnum,THexOwnership* centers,bool CanHaveSameCenterEntityNumber) throw (E_8K_Editor_InvalidCenters);

#endif


