/**
*******************************************************************************

  @file /gui/common/Defs.h
  @brief identifikace resourcu


  @author Pavel
  @version 0.1
 
******************************************************************************/


#ifndef DEFS_H
#define DEFS_H


namespace gui{


/// cisla rasteru terenu
#define RASTER_GRASS		11
#define RASTER_ROCK			12
#define RASTER_GRASSROCK	15
#define RASTER_ROCKGRASS	16
#define RASTER_WATER		17
#define RASTER_SWAMP		21
#define RASTER_GRASSSWAMP	22
#define RASTER_SWAMPGRASS	23
#define RASTER_ROCKSWAMP	24
#define RASTER_SWAMPROCK	25

/// misc
#define RASTER_SMOKE		13
#define RASTER_SHADOW		14
#define RASTER_PARTICLE	30
#define RASTER_EXNOISE	31
#define RASTER_WAVE	    32
#define RASTER_HEART_PARTICLE	120
#define RASTER_CROSS_PARTICLE	121
#define RASTER_HEAD_PARTICLE	122

/// gui
#define RASTER_PANEL		      9
#define RASTER_MAINMENU_BG    100
#define RASTER_DEFEAT         101
#define RASTER_VICTORY        102
#define RASTER_WAITING        103
#define RASTER_ICONS		      10
#define RASTER_UA_ICONS		    26
#define RASTER_BA_ICONS		    27
#define RASTER_SPELLS_ICONS		28
#define RASTER_BONUS_ICONS		29
#define RASTER_CHOOSEMAP_BG   104
#define RASTER_TERRAINS		    125

/// modely terenu
#define MODEL_TREE					81
#define MODEL_TREE2					82
#define MODEL_TREE3					90
#define MODEL_TREE4					89
#define MODEL_FERN1					83
#define MODEL_ROCK1					84
#define MODEL_ROCK2					85
#define MODEL_ROCK3					86
#define MODEL_HOUSE1				87
#define MODEL_HOUSE2				88

/// zbyvajici modely
#define MODEL_FLAG					57
#define MODEL_ARROW					91
#define MODEL_CATAPULT_PROJECTILE			92
#define MODEL_MAGIC_MISSILE 92
#define MODEL_BORDERSTONE   93

/// identifikatory animaci
#define MODEL_ANIM_WALK           0
#define MODEL_ANIM_FIGHT          1
#define MODEL_ANIM_DISTANTATTACK  1
#define MODEL_ANIM_DIE            2

/// cisla textu
#define TEXT_EVENT_ENEMYAPPEARED	  300
#define TEXT_EVENT_UNITUNDERATTACK  301 
#define TEXT_EVENT_CONSTABORTED     302
#define TEXT_EVENT_PENALTY          303
#define TEXT_EVENT_PENALTY2	        304
#define TEXT_EVENT_WEATHER		      305
#define TEXT_EVENT_UNITWASDISBANDED	306
#define TEXT_EVENT_UNITINTERRPUTED	307
#define TEXT_EVENT_WILLDIE          308
#define TEXT_EVENT_UNITDIED         309
#define TEXT_EVENT_UNHEALEDWOUNDS   310
#define TEXT_EVENT_UNHEALEDMEN      311
#define TEXT_EVENT_LOWMONEY	        312

#define TEXT_ERROR			          313
#define TEXT_SERVER_PLAYER        317
#define TEXT_HUMAN_PLAYER         318
#define TEXT_GAMESTART_ERROR      319

#define TEXT_EVENT_BUILDINGUNDERATTACK   320


#define TEXT_SINGLE			400
#define TEXT_MULTI			401
#define TEXT_OPTIONS		402
#define TEXT_CREDITS		403
#define TEXT_QUIT			  404
#define TEXT_PLAY			  405
#define TEXT_LOAD			  406
#define TEXT_BACK			  407
//#define TEXT_LOCAL			408
#define TEXT_DIRECTHOST	409
#define TEXT_DIRECTJOIN	410
#define TEXT_MAP			  411
#define TEXT_INFO			  412
#define TEXT_PLAYERS		413
#define TEXT_SIZE			  414
#define TEXT_CHAT			  415
#define TEXT_SEND			  416
#define TEXT_HOSTIP			417
#define TEXT_YOURNAME		418
#define TEXT_CONNECT		419
#define TEXT_8KINGDOMS	420	
#define TEXT_DISCONNECT	421
#define TEXT_DESTROYGAME  422
#define TEXT_NAME			    423
#define TEXT_ADD			    424
#define TEXT_DELETE			  425
#define TEXT_CHOSEMAP		  426
#define TEXT_NEWGAME		  427
#define TEXT_PROFILENAME	430
#define TEXT_PROFILEADD		431
#define TEXT_PROFILEOK		432
#define TEXT_PROFILEDEL		433
#define TEXT_PROFILECHANGE	434
#define TEXT_PROFILES		    435
#define TEXT_PRIMARYPLAYER	436
#define TEXT_OTHERPLAYER	  437
#define TEXT_AI				      438
#define TEXT_DIFICULTY      439
#define TEXT_APPLY          440
#define TEXT_ROLEOPTIONS	  441
#define TEXT_ROLES			    442
#define TEXT_PLAYER			    443
#define TEXT_LOADING		    444
//#define TEXT_AI_AI			    445
#define TEXT_AI_1			      446
#define TEXT_AI_2			      447
#define TEXT_AI_3			      448
#define TEXT_MAPDESCRIPTION	449
#define TEXT_SAVE						450
#define TEXT_MENU						451
#define TEXT_OK							452
#define TEXT_SPEED					453
#define TEXT_MUSICVOLUME		454
#define TEXT_SOUNDVOLUME		455
#define TEXT_SAVEDGAMES			456
#define TEXT_SAVEAS					457

#define TEXT_OWNER					458
#define TEXT_BONUSES				459
#define TEXT_LIVES					460
#define TEXT_MOVEPOINTS			461
#define TEXT_EXPERIENCE			462
#define TEXT_LEVEL					463
#define TEXT_SPELLS					464
// #define TEXT_PRODUCINGUNIT	465
#define TEXT_PROGRESS				466
#define TEXT_ISBUILDING			467
// #define TEXT_INBUILDING			468
// #define TEXT_NOONE					469
#define TEXT_DIPLOMACY      470
// #define TEXT_ONTURN         471
#define TEXT_RELATIONS      472
#define TEXT_HUMANPLAYER    473
#define TEXT_WAITFORCLIENTS 474
#define TEXT_ERRCONNECTION  475
#define TEXT_STOPWAITING    476
#define TEXT_DISCONNECTED   477

#define TEXT_ENTERPHASE2    478
#define TEXT_INITGUIMAP     479
#define TEXT_INITMINIMAP    480
#define TEXT_GAMEREADY      481
#define TEXT_FULSCREEN      482
#define TEXT_LANGUAGE       483
#define TEXT_RESOLUTION     484
#define TEXT_OPTIONSALERT   485
#define TEXT_SERVER         486
#define TEXT_HASCONNECTED   487
#define TEXT_HASDISCONNECTED 488

#define TEXT_ENDTURN              489
#define TEXT_NEXTUNIT             490
#define TEXT_PREVUNIT             491
#define TEXT_MINIMAPUNITS         492
#define TEXT_MINIMAPHIGHTLEVELS   493
#define TEXT_MINIMAPRASES         494
#define TEXT_MINIMAPKINGDOMS      495

#define TEXT_8KWW                 496
#define TEXT_LANGAMES             497
#define TEXT_ANNOUNCE_GAMES       498
#define TEXT_AUTOSAVE             499

#define TEXT_YOU_WERE_DEFEATED    550
#define TEXT_GAME_WAS_CANCELED    551
#define TEXT_SERVER_WAS_CLOSED    552
#define TEXT_WINNER_WON           553
#define TEXT_CITIES_CONQUERED     554
#define TEXT_AFTER_TIME_GAME_ENDS 555
#define TEXT_PLAYER_DEFEATED      556
#define TEXT_GAME_ABORTED         557
#define TEXT_DRAW_GAME            558
#define TEXT_GAME_ENDING          559

#define TEXT_UNIT_MOVE            601
#define TEXT_UNIT_ATTACK          602
#define TEXT_UNIT_HEAL            603
#define TEXT_UNIT_RECRUIT         604
#define TEXT_UNIT_RECRUIT_ELITE   605
#define TEXT_UNIT_BUILD           606
#define TEXT_UNIT_STOPBUILDING    607
#define TEXT_UNIT_REPAIR          608
#define TEXT_UNIT_SUICIDE         609

#define TEXT_BUILING_RECRUIT      621
#define TEXT_BUILING_SELLBONUS    622
#define TEXT_BUILING_SUICIDE      623

#define TEXT_TURNLEFT             631
#define TEXT_TURNRIGHT            632

#define TEXT_RELWAR               641
#define TEXT_RELENEMY             642
#define TEXT_RELTRUCE             643
#define TEXT_RELALLY              644

#define TEXT_RESUME               651
#define TEXT_CLOSE                652
#define TEXT_DIPLOMAT             653
#define TEXT_ACTUAL               654
#define TEXT_OFFERED              655
#define TEXT_POSSIBILITY          656
#define TEXT_CENTER               657
#define TEXT_WARNINGS             658
#define TEXT_INFOS                659
#define TEXT_COMMENTS             660
#define TEXT_CONNECTIONLOST       661
#define TEXT_MAINMENU             662
#define TEXT_MENKILLED            663
#define TEXT_MENLOST              664
#define TEXT_UNITTRAINED          665
#define TEXT_BUILDINGDESTROIED    666
#define TEXT_BUILDINGLOST         667
#define TEXT_BUILDINGBUILT        668
#define TEXT_BUILDINANNEXED       669
//#define TEXT_ANOTHERBATTLE        670
//#define TEXT_REPLAY               671
#define TEXT_MONEYEARNED          672

#define TEXT_EVENT_BATTLE             681
#define TEXT_EVENT_BUILDINGANNEXION   682
#define TEXT_EVENT_TOWNANNEXED        683
#define TEXT_EVENT_ANNEXEDTOWN        684
#define TEXT_EVENT_KINGDOMANNEXED     685
#define TEXT_EVENT_ANNEXEDKINGDOM     686
#define TEXT_EVENT_TRG_RELBECOMEWAR      687
#define TEXT_EVENT_TRG_RELBECOMEENEMY    688
#define TEXT_EVENT_TRG_RELBECOMENEUTRAL  689
#define TEXT_EVENT_TRG_RELBECOMEALLY     690
#define TEXT_EVENT_TRG_RELOFFERWAR       691
#define TEXT_EVENT_TRG_RELOFFERENEMY     692
#define TEXT_EVENT_TRG_RELOFFERNEUTRAL   693
#define TEXT_EVENT_TRG_RELOFFERALLY      694
#define TEXT_EVENT_NEWROUND           695
#define TEXT_EVENT_GOLDPROFIT         696
#define TEXT_EVENT_BUILDINGHEAL       697
#define TEXT_EVENT_BUILDINGBUILT      698
#define TEXT_EVENT_BUILDINGREPAIRED   699
#define TEXT_EVENT_SRC_RELBECOMEWAR      700
#define TEXT_EVENT_SRC_RELBECOMEENEMY    701
#define TEXT_EVENT_SRC_RELBECOMENEUTRAL  702
#define TEXT_EVENT_SRC_RELBECOMEALLY     703
#define TEXT_EVENT_SRC_RELOFFERWAR       704
#define TEXT_EVENT_SRC_RELOFFERENEMY     705
#define TEXT_EVENT_SRC_RELOFFERNEUTRAL   706
#define TEXT_EVENT_SRC_RELOFFERALLY      707

#define TEXT_SHORTCUTKEY            711
#define TEXT_COST                   712
#define TEXT_PAY                    713
#define TEXT_CONSTRDURATION         714

//tereny
#define TEXT_TERRAIN_PLAIN        750
#define TEXT_TERRAIN_FOREST       751
#define TEXT_TERRAIN_DEEP_FOREST  752
#define TEXT_TERRAIN_ROCKS        753
#define TEXT_TERRAIN_SWAMP        754
#define TEXT_TERRAIN_RIVER        755
#define TEXT_TERRAIN_SEA          756
#define TEXT_TERRAIN_SHALLOW      757
#define TEXT_TERRAIN_TOWN         758

#define TEXT_ENDGAME_CAPTION    770
#define TEXT_ENDGAME_1          771
#define TEXT_ENDGAME_2          772

/// samples ID
#define SAMPLE_CLICK            2

/// misc sound 
#define SAMPLE_THUNDER          5
#define SAMPLE_DESTRUCTION      7
#define SAMPLE_EXPLOSION        8
#define SAMPLE_ARROW_ATTACK     9
#define SAMPLE_CATAPULT_ATTACK  70
#define SAMPLE_SPARKLE          100
#define SAMPLE_GONG             101
#define SAMPLE_FIREBALL         102

/// unit sound type
#define SOUND_COMMAND_SELECTED      1
#define SOUND_COMMAND_DEATH         2
#define SOUND_COMMAND_ACKNOWLEDGE   3
#define SOUND_COMMAND_ENEMYSELECTED 4

/// ID skladeb
#define MUSIC_BATTLE_THEME_1  61
#define MUSIC_BATTLE_THEME_2  62
#define MUSIC_BATTLE_THEME_3  63
#define MUSIC_BATTLE_THEME_4  64
#define MUSIC_BATTLE_THEME_5  65
#define MUSIC_BATTLE_THEME_6  66
#define MUSIC_BATTLE_THEME_7  67
#define MUSIC_MAINMENU_THEME_1  1
#define MUSIC_FINAL_THEME_1     6

/// playlist ID
#define MUSIC_BATTLE_THEME    2
#define MUSIC_MAINMENU_THEME  1
#define MUSIC_FINAL_THEME     3

//symboly
#define SYMBOLS_BASIC_ICONS     2
  //tady muze byt vycet vsech misto hodnot natvrdo ve zdrojaku

#define SYMBOLS_UNIT_ICONS      3
#define SYMBOLS_BUILDING_ICONS  4
#define SYMBOLS_BONUS_ICONS     5
#define SYMBOLS_TERRAINS        6

//ikony
#define ICON_UNIT_PORTRAIT      1
#define ICON_UNIT_BIGPORTRAIT   2
#define ICON_UNIT_ICON					3
#define ICON_UNIT_EDITORICON    5
#define ICON_UNIT_MOVE          11
#define ICON_UNIT_ATTACK        12
#define ICON_UNIT_SUICIDE       13
//#define ICON_UNIT_CRY           14
#define ICON_UNIT_RECRUIT       15
#define ICON_UNIT_RECRUIT_ELITE 16
#define ICON_UNIT_START_BUILDING  18
#define ICON_UNIT_STOP_BUILDING   19
#define ICON_UNIT_REPAIR_BUILDING 20
//#define ICON_UNIT_CAST_SPELL    21
//#define ICON_UNIT_MEDITATE      22
#define ICON_UNIT_HEAL          23
#define ICON_UNIT_RETURN        31
#define ICON_UNIT_YES           32
#define ICON_UNIT_NO            33

#define ICON_BUILDING_PORTRAIT      1
#define ICON_BUILDING_ICON          3
#define ICON_BUILDING_SUICIDE       11
#define ICON_BUILDING_RECRUIT_UNIT  12
#define ICON_BUILDING_SELL_BONUS    13
#define ICON_BUILDING_RETURN        21
#define ICON_BUILDING_YES           22
#define ICON_BUILDING_NO            23
#define ICON_BUILDING_LEFT          24
#define ICON_BUILDING_RIGHT         25

#define ICON_BASIC_GOLD     10
#define ICON_BASIC_PLAYER   12
#define ICON_BASIC_HEX      11

//identifikatry svetelnejch zdroju
#define LIGHTSOURCE_SUN       1
#define LIGHTSOURCE_LIGHTING  2

// rozsireny seznam roli pro gui
enum MYROLETYPE { MPT_UNUSED, MPT_MAINHUMAN, MPT_HUMAN, MPT_AI_1, MPT_AI_2, MPT_AI_3};

} //namespace

#endif

/*****************************************************************************/
