/**
*******************************************************************************

  @file /gui/common/chatbox.h
  @brief graficke rozhrani chatboxu
  

  @author Pavel
  @version 0.1
 
******************************************************************************/
#ifndef CHATBOX_H
#define CHATBOX_H

#include "gui/common/ActiveObjects.h"

namespace gui{

/** Chat box. */
class TChatBox : public TGroupBar
{
private:
  /// GUI ovladaci prvky.
  //@{
  TLineTextField *tfmessage;
  TListBar *lbmessages;
  TLabel *lchat;
  TTextButton *bsend;
  //@}
  /// Id klienta, jehoz jmenem se posilaji zpravy z tohoto okna.
  int client_id;
  bool isHost;
public:
	/// Vytvori seznam zprav,... a napoji se na sit.
  TChatBox(rm::TRM_txt_i *rmtxti, int _x, int _y, int _width, int _height, bool _isHost = false);
  /// Prijme package se zpravou.
  void receiveMsg(TPackage *p);
  /// Zobrazi zpravu obsazenou v package.
  void showPackage(TPackage *p);
  /// Prime poslani zpravy od serveru.
  void directSend(char *name, char *msg);
	/// Zpracovani vstupu.
  virtual int workInput(INPUT *input);
};

class TOSD;

/** Chat box na OSD. */
class TOSDChatBox : public TGroupBar
{
private:
  /// GUI ovladaci prvky.
  //@{
  TLineTextField *line;
  TLabel *caption;
  int client_id;
  //@}
 
  /// Ukazatel na osd do ktereho se provadi vystup.
  TOSD *osd;
  int red, green, blue; 
public:
  /// Vytvori seznam zprav,... a napoji se na sit.
	TOSDChatBox(TOSD *_osd, int _x, int _y, int _msglength);
  /// Nastavi id klienta a cislo role.
  void setClientColor(int _client_id, int _red, int _green, int _blue);
  /// Prijme package se zpravou.
  void receiveMsg(TPackage *p);
  /// Zobrazi zpravu obsazenou v package.
  void showPackage(TPackage *p);
  /// Prime poslani zpravy od serveru.
  void directSend(char *name, char *msg, int _red = -1, int _green = -1, int _blue = -1);
	/// Zajistuje psani, odesilani a staly focus.
  virtual int workInput(INPUT *input);
  /// Zobrazi radek pro psani zprav.
  virtual void show();
  /// Schova radek pro psani zprav.
  virtual void hide();
};


} // namespace;




#endif
/*****************************************************************************/
