/**
*******************************************************************************

  @file /gui/contexts/FinalStatistic.h
  @brief Obrazovka FinalStatistic
  

  @author Pavel
  @version 0.1
 
******************************************************************************/
#ifndef FINALSTATISTIC_H
#define FINALSTATISTIC_H

#include "gui/common/Context.h"
#include "gui/common/ActiveObjects_ext.h"
#include "common/rm/rminit.h"

namespace gui{

/** Data pro finalni obrazovku. */
class TGuiEndGame //## 
{  
public:
  /// cislo viteze
  int winner;
  /// duvod vyhry
  World::ENDGAME_REASON reason;
  /// seznam hracu - odkaz do worldu
  World::TPlayerContainer * players;  
  /// konstruktor
  TGuiEndGame(World::ENDGAME_REASON r, World::TPlayerContainer * p, int w); 
};

/** Hlavni okno kontextu FinalStatistic. */
class TStatisticWindow : public TWindow {
public:
  TStatisticWindow(TContextPrimaryParameter cpp, TGuiEndGame* eg);
  /// Graficke komponenty okna
  //@{
  TGroupBar* gimage;
  TGroupBar* gdescription;
  TGroupBar* gtable; 
  TTextButton *bmenu;
  TTextButton *bnext;
  TTextButton *brepeat;
  //@}
};

/** Kontext se statistikama */
class TFinalStatistic : public TContext {
private:
  TStatisticWindow *statisticwindow;
  TErrorWindow *gamedisconnectedwindow;
public:
  TFinalStatistic(TContextParameter contextparameter);
  virtual ~TFinalStatistic();

  /// inicializacni, aktivacni a deaktivacni kontextove metody
  //@{ 
  static TContext* createContext(...);
  virtual void activateContext(TContextParameter contextparameter);
  virtual void deactivateContext();
  //@}

  /// GUI vystup a vstup.
  //@{
  virtual void drawContext();
  virtual int workInput(INPUT *input);
  //@}

};

}//namespace
#endif
/*****************************************************************************/
