/**
*******************************************************************************

  @file /gui/contexts/LoadingScreen.h
  @brief Obrazovka LoadingScreen
  

  @author Vajicek
  @version 0.1
 
******************************************************************************/
#ifndef LOADINGSCREEN_H
#define LOADINGSCREEN_H

#include "gui/common/Context.h"
#include "gui/common/ActiveObjects_ext.h"
#include "common/rm/rminit.h"

//
#include "world/world_messages.h"

namespace gui{

/** Hlavni okno kontextu LoadingScreen. */
class TLoadingWindow : public TWindow {
public:
	TLabel *lcaption;
	TLabel *lstatemsg;
  TProgressBar* pbar;
	TLoadingWindow(rm::TRM_txt_i *rmtxti);
};


/** Kontext, ktery podava informace o prubehu nacitani a inicializaci. */
class TLoadingScreen: public TContext{
private:
	TLoadingWindow *loadingwnd;
  TErrorWindow* notice;
  //
	rm::TRM_txt_i *rmtxti;
public:
  /// Predava typ hry, ktera se nahrava, lokalni/sitova.
	TContextParameter gamemode; 
  /// Priznak, zda uz je nahrano gui.
  int guiMapReady;
  /// Priznak, zda prisla zprava letsgo.
  int letsGo;
  
  /// Inicializacni, aktivacni a deaktivacni kontextove metody.
  //@{ 
	TLoadingScreen(TContextParameter contextparameter);
	virtual ~TLoadingScreen();
	static TContext* createContext(...);
	virtual void activateContext(TContextParameter contextparameter);
	virtual void deactivateContext();
  //@}

  /// GUI vystup a vstup.
  //@{
	virtual void drawContext();
  virtual int workInput(INPUT *input);
  //@}
 
  /// Komunikace s okolim.
  //@{
  /// Zpracuje zpravu o ukonceni hry(vetsinou z duvodu chyby).
  void endGame(TPacket_END_GAME* eg);
  /// Zmeni text zpravy v okne.
  void showStateMsg(wchar_t* msg);
  /// Zmeni indikator nahravani.
  void setProgress(float i);
  //@}

};

}//namespace
#endif
/*****************************************************************************/
