/**
******************************************************************************

  @file /net/mysocket.cpp
  @brief Definice vlastnich funkci pro komunikaci pres sit
 
  @author Vta
  @version 1.0

******************************************************************************/
#include "mysocket.h"
#include "common/Log.h"

namespace net
{

int MySend(mysocket sock,const char * msg,size_t len)
{
#ifdef WIN32
  return send(sock,msg,(int)len,0);
#else
  return (int)write(sock, msg, len);
#endif
}

int MySendto (mysocket s, const char *buf, int len, int flags, const struct sockaddr *to, mysocklen_t tolen )
{
  return sendto(s,buf,len,flags,to,tolen);
}

int MyRecv(mysocket sock,char * msg,size_t len)
{
  int i;
//  for (i=0;i<len;i++)
//    msg[i]=0;
#ifdef WIN32
  i=recv(sock,msg,(int)len,0);
//  GLOBALLOGID(10, msg);
#else
  i=read(sock,msg,len);
#endif
  return i;
}

int MyRecvfrom(mysocket s, char *buf, int len, int flags, struct sockaddr *from, mysocklen_t *fromlen )
{
  return recvfrom(s,buf,len,flags,from,fromlen);
}


mysocket MySocket()
{
#ifdef WIN32
  return socket(AF_INET, SOCK_STREAM, 0);
#else
  return socket(AF_INET, SOCK_STREAM, 0);
#endif
}

mysocket MyUDPSocket()
{
#ifdef WIN32
  return socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
#else
  return socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
#endif
}

int MyCloseSocket(mysocket sock)
{
#ifdef WIN32
  return closesocket (sock); 
#else
  return close(sock);
#endif
}

int MyStartNetwork()
{
#ifdef WIN32
  WSADATA wsdata; // info
  return WSAStartup(0x0101,&(wsdata));
#else  
  return 0; // nic
#endif
}

int MyStopNetwork()
{
#ifdef WIN32
  return WSACleanup();
#else
  return 0; // nic
#endif
}

int MyConnect(mysocket sock, const struct sockaddr *name, int namelen ) 
{
#ifdef WIN32
  return connect(sock,name,namelen);
#else
  return connect(sock,name,namelen);
#endif
}

int MyListen(mysocket sock,int backlog)
{
#ifdef WIN32
  return listen(sock,backlog);
#else
  return listen(sock,backlog);
#endif
}

int MyBind(mysocket sock, const struct sockaddr *addr, int namelen)
{
#ifdef WIN32
  return bind(sock,addr,namelen);
#else
  return bind(sock,addr,namelen);
#endif
}
/*
int MyGetLastError()
{
#ifdef WIN32
  return WSAGetLastError();
#else
  // nic
#endif
}
*/
int MySelect (int nfds, fd_set *readfds, fd_set *writefds, fd_set *exceptfds, struct timeval *timeout)
{
#ifdef WIN32
  return select(nfds,readfds,writefds,exceptfds,timeout);
#else
  return select(nfds,readfds,writefds,exceptfds,timeout);
#endif
}

}
